/* Comp 116 Spring 2021, programming assignment 5
 * Copyright (c) 2021
 * Wheaton College, Computer Science Department, Norton MA
 * M. Gagne
 */

#ifndef PRGASST07_H_
#define PRGASST07_H_

#include <string>
#include <unordered_map>
#include <vector>
#include <utility>
#include "dictionary.h"
#include "position.h"

using std::string;
using std::unordered_map;
using std::vector;

class MyDictionary : public Dictionary<string,Position*> {
 protected:
  unordered_map<string,Position*> theMap;

 public:
  MyDictionary();
  ~MyDictionary();

  bool isEmpty();
  int getSize();
  void insert(string key, Position* value);
  void update(string key, Position* value);
  Position* find(string key);
  bool contains(string key);
  void remove(string key);
  vector<string> getKeys();
  vector<pair<string,Position*>> getItems();
};

#endif
